Scriptname GT01SCRPTMilkCow extends ObjectReference  
;
;This script is for milking cows
;==============================================================

Import Game
Import Utility
Import Debug
Import Math

Potion Property MilkPot01 Auto
{Add potion 1 here}

Potion Property MilkPot02 Auto
{Add potion 2 here}

Ingredient  Property MilkIng01 Auto
{Add ingredient 1 here}

Ingredient  Property MilkIng02 Auto
{Add ingredient 2 here}

Int Property HowManyPot01Per Auto
{Seleect amount of potion 1 to be gained per milking, e.g, 1, 2, etc.}

Int Property HowManyPot02Per Auto
{Seleect amount of potion 2 to be gained per milking, e.g, 1, 2, etc.}

Int Property HowManyIng01Per Auto
{Seleect amount of ingredient 1 to be gained per milking, e.g, 1, 2, etc.}

Int Property HowManyIng02Per Auto
{Seleect amount of ingredient 2 to be gained per milking, e.g, 1, 2, etc.}

String Property Potion01Name Auto
{Add the name of potion 1 that will be shown when milked}

String Property Potion02Name Auto
{Add the name of potion 2 that will be shown when milked}

String Property ingredient01Name Auto
{Add the name of ingredient 1 that will be shown when milked}

String Property Ingredient02Name Auto
{Add the name of ingredient 2 that will be shown when milked}

MISCOBJECT PROPERTY Bucket AUTO
{Add a bucket to go under the cow}

String Property DaystoWait Auto
{Select amount of days to wait between milking, e.g 1.00, 2.00 etc.}

Static Property XMark Auto
{XMarker or static non-collision bucket, must be used to set player direction}

sound property MilkingSound auto
{Find a sound to play once per second while milking}

Idle Property IdleStop_Loose Auto
{Autofill}

String property FailureMessage auto
{Message that appears when you have already milked this cow}

Float OffsetAngle
Float OffsetDistance 

ObjectReference MilkingBucket
ObjectReference XMarkCrouch 

float property lastHarvestedDay auto Hidden
{the game day this was last successfuly harvested, used to know when to respawn}

Int CowIsDead = 0

;===================================================================
;;STATE BLOCK
;===================================================================

auto state readyForHarvest
	event onActivate(objectReference akActivator)
		goToState("waitingToRespawn")
		fakeHarvest(akActivator)
	endEvent
endState

state waitingToRespawn
	event onBeginState()
		lastHarvestedDay = utility.getCurrentGameTime()
	endEvent

	event onActivate(objectReference akActivator)
If CowIsDead == 1
Else
		Notification(FailureMessage)
EndIf
	endEvent

	event onCellLoad()
		Utility.Wait(1.00)
		if (lastHarvestedDay + DaystoWait) <= utility.getCurrentGameTime()
			goToState("readyForHarvest")
		endif
	endEvent
endState

;===================================================================
;;FUNCTION BLOCK
;===================================================================


Event OnDeath(Actor akKiller)

CowIsDead = 1

EndEvent


function fakeHarvest(objectReference akActivator)

	if (akActivator as actor)
Actor Player = Game.GetPlayer()
If CowIsDead == 1
Else
Debug.SendAnimationEvent(Self, "cowFeedStart")
MilkingBucket = Self.PlaceAtMe(Bucket)
MilkingBucket.SetScale(0.5)
MilkingBucket.MoveTo(Self, -60 * Math.Sin(Self.GetAngleZ()), -60 * Math.Cos(Self.GetAngleZ()), abMatchRotation = true)
Game.ForceThirdPerson()
Game.DisablePlayerControls(abMovement = true, abFighting = false, abCamSwitch = true, abLooking = false, abSneaking = false, abMenu = true, abActivate = false, abJournalTabs = false)
XMarkCrouch = MilkingBucket.PlaceAtMe(XMark)
XMarkCrouch.MoveTo(Self, -60 * Math.Sin(Self.GetAngleZ()), -60 * Math.Cos(Self.GetAngleZ()), abMatchRotation = true)
Utility.Wait(0.5)
Game.SetPlayerAIDriven()
Player.SetLookAt(XMarkCrouch , true)
float AngleZ = XMarkCrouch .GetAngleZ() + OffsetAngle
float OffsetX = OffsetDistance * Math.Sin(AngleZ)
float OffsetY = OffsetDistance * Math.Cos(AngleZ) + 50
Player.MoveTo(XMarkCrouch, 30 * Math.Sin(XMarkCrouch.GetAngleZ()), 30 * Math.Cos(XMarkCrouch.GetAngleZ()), Self .GetHeight() + 15)
Player.SetAngle(XMarkCrouch .GetAngleX(), XMarkCrouch .GetAngleY(), XMarkCrouch .GetAngleZ() + \
 Player.GetHeadingAngle(XMarkCrouch ))
Player.SetLookAt(XMarkCrouch , true)
Utility.wait(1.0)
Debug.SendAnimationEvent(Player, "IdleWarmHandsCrouched")
Utility.wait(1.0)
int instanceID = MilkingSound.play(self)
Utility.wait(0.4)
Sound.StopInstance(instanceID)
Utility.wait(1.0)
int instanceID2 = MilkingSound.play(self)
Utility.wait(0.4)
Sound.StopInstance(instanceID2)
Utility.wait(1.0)
int instanceID3 = MilkingSound.play(self)
Utility.wait(0.4)
Sound.StopInstance(instanceID3)
Utility.wait(1.0)
int instanceID4 = MilkingSound.play(self)
Utility.wait(0.4)
Sound.StopInstance(instanceID4)
Utility.wait(1.0)

If MilkPot01
Player.AddItem(MilkPot01,HowManyPot01Per,true)
Notification(HowManyPot01Per + " " + Potion01Name)
EndIf
If MilkPot01
Player.AddItem(MilkPot02,HowManyPot02Per,true)
Notification(HowManyPot02Per + " " + Potion02Name)
EndIf
If MilkPot01
Player.AddItem(MilkIng01,HowManyIng01Per,true)
Notification(HowManyIng01Per + " " + Ingredient01Name)
EndIf
If MilkPot01
Player.AddItem(MilkIng02,HowManyIng02Per,true)
Notification(HowManyIng02Per + " " + Ingredient02Name)
EndIf

Player.PlayIdle(IdleStop_Loose)
Game.EnablePlayerControls()
MilkingBucket.Delete()
XMarkCrouch.Delete()
Utility.wait(1.0)
Game.ForceFirstPerson()
Game.SetPlayerAIDriven(False)
	endif
EndIf
endFunction

